/*
 * KernelConf - A Linux Kernel Configuration System
 *
 * Distributed under GNU General Public Lisence
 *
 * Copyright (C) 2002 by Anuradha Ratnaweera
 */

#ifndef _KCONF_SYMBOLS_H
#define _KCONF_SYMBOLS_H

#include "expressions.h"
#include "tree.h"

typedef struct _Symbol* SymbolPtr;
typedef struct _Menu* MenuPtr;

typedef enum {
    TYPE_NULL,
    TYPE_BOOL,
    TYPE_TRI,
    TYPE_INT,
    TYPE_CHAR,
    TYPE_STR
} SymbolType;

typedef struct _Symbol {
    Node node;
    SymbolType type;
    union {
	char charval;
	int intval;
	char *strval;
    } value;
    ExpressionPtr depends;
    ExpressionPtr derived;
    MenuPtr menu_item;
} Symbol;

typedef struct _Menu {
    Node node;
    MenuPtr parent, child;
    char *caption;
    ExpressionPtr depends;
    SymbolPtr symbol;
} Menu;

#endif /* _KCONF_SYMBOLS_H */

