/*
 * KernelConf - A Linux Kernel Configuration System
 *
 * Distributed under GNU General Public Lisence
 *
 * Copyright (C) 2002 by Anuradha Ratnaweera
 */

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"
#include "symbols.h"

extern MenuPtr root_menu_item;

static char read_char_input()
{
    char c;

    do {
	c = getchar();
    } while (isspace(c));
    return c;
}

static void show_help(SymbolPtr symbol)
{
}

static void do_menu(MenuPtr menu)
{
    char c, cin;
    char ok;

    do {
	ok = 0;
	if (menu->symbol) {
	    printf("%s (CONFIG_%s)", menu->caption, ((NodePtr)menu->symbol)->key);
	    switch (menu->symbol->type) {
		case TYPE_BOOL:
		    c = menu->symbol->value.charval;
		    printf(" [%c/%c/?] ", c == 'y' ? 'Y' : 'y',
			    c == 'n' ? 'N' : 'n');
		    cin = read_char_input();
		    if (strchr("YyNn", cin)) {
			menu->symbol->value.charval = tolower(cin);
			ok = 1;
		    }
		    else
			show_help(menu->symbol);
		    break;
		case TYPE_TRI:
		    break;
		case TYPE_INT:
		    break;
		case TYPE_CHAR:
		    break;
		case TYPE_STR:
		    break;
		case TYPE_NULL:
		    break;
	    }
	}
	if (menu->child) {
	    printf("*\n");
	    printf("* %s\n", menu->caption);
	    printf("*\n");
	    do_menu(menu->child);
	    ok = 1;
	}
	if (ok)
	    menu = (MenuPtr)((NodePtr)menu)->next;
    } while (menu);
}

int do_ttyconfig()
{
    if ((root_menu_item == NULL) || (root_menu_item->child == NULL))
	return 1;

    do_menu(root_menu_item->child);

    return 0;
}

